#include <stdio.h>
#include <string.h>
#include <wchar.h>

#include "xmalloc.h"
#include "stringcache.h"
#include "util.h"

typedef struct cacheS {
	struct cacheS	*nextP;
	char			*stringP;
} cacheT;

static cacheT	*hashtable[0x4000] = {0};

static cacheT	*g_cacheP   = 0;
static int		g_cache_lth = 0;
static int		left        = 0;

// All identical strings passed through stringCache will have the same resulting address

const char *
stringCache(const char *stringP)
{
	const char	*P;
	char		*string1P;
	int			hash;
	cacheT		*cacheP;
	int			c, lth;

	hash = 0;
	for (P = stringP; (c = *P); ++P) {
		hash <<= 1;
		hash  ^= c;
	}
	hash &= 0x3FFF;
	for (cacheP = hashtable[hash]; cacheP; cacheP = cacheP->nextP) {
		if (!strcmp(stringP, cacheP->stringP)) {
			return cacheP->stringP;
	}	}
	if (left == 0) {
		left  = 2048;
		g_cache_lth = sizeof(cacheT) * 2048;
		g_cacheP = (cacheT *) Xmalloc(g_cache_lth);
		if (!g_cacheP) {
			outofmemory();
		}
	}
	cacheP = g_cacheP + --left;
	cacheP->nextP   = hashtable[hash];
	lth             = (P - stringP) + 1;
	string1P        = (char *) Xmalloc(lth);
	memcpy(string1P, stringP, lth);
	cacheP->stringP = string1P;
	hashtable[hash] = cacheP;
	return string1P;
}
